package mrtjp.projectred.exploration;

import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import mrtjp.projectred.ProjectRedExploration;
import mrtjp.projectred.exploration.BlockSpecialStone.EnumSpecialStone;
import net.minecraft.init.Blocks;
import net.minecraft.block.Block;
import net.minecraft.block.BlockWall;
import net.minecraft.block.material.Material;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.IIcon;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;

import java.util.List;

public class BlockSpecialStoneWall extends BlockWall
{
    public BlockSpecialStoneWall()
    {
        super(Blocks.stone);
        this.setBlockName("projectred.exploration.stonewalls");
        setCreativeTab(ProjectRedExploration.tabExploration());
    }

    @SideOnly(Side.CLIENT)
    @Override
    public IIcon getIcon(int side, int meta)
    {
        return BlockSpecialStone.EnumSpecialStone.VALID_STONE[meta].texture;
    }

    @SideOnly(Side.CLIENT)
    @Override
    public void getSubBlocks(Item item, CreativeTabs tab, List list)
    {
        for (EnumSpecialStone s : EnumSpecialStone.VALID_STONE)
            list.add(new ItemStack(ProjectRedExploration.blockStoneWalls(), 1, s.meta));
    }

    @Override
    /**
     * Return whether an adjacent block can connect to a wall.
     */
    public boolean canConnectWallTo(IBlockAccess w, int x, int y, int z)
    {
        Block block = w.getBlock(x, y, z);

        if (block != this && block != Blocks.fence_gate)
        {
            return block.getMaterial().isOpaque() && block.renderAsNormalBlock() && block.getMaterial() != Material.gourd;
        }
        else
            return true;
    }

    @Override
    public boolean canPlaceTorchOnTop(World world, int x, int y, int z)
    {
        Block block = world.getBlock(x, y, z);
        return super.canPlaceTorchOnTop(world, x, y, z) || block == ProjectRedExploration.blockStoneWalls();
    }
}
