package mrtjp.projectred.illumination;

import mrtjp.projectred.ProjectRedIllumination;
import mrtjp.projectred.core.ItemPart.EnumPart;
import net.minecraft.init.Blocks;
import net.minecraft.block.Block;
import net.minecraft.init.Items;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import cpw.mods.fml.common.registry.GameRegistry;

public class IlluminationRecipes
{
    public static void initRecipes()
    {
        initLightingRecipes();
    }

    private static void initLightingRecipes()
    {
        /** Lamps **/
        for (int i = 0; i < 16; i++)
        {
            GameRegistry.addRecipe(new ItemStack(ProjectRedIllumination.blockLamp(), 1, i),  // Regular
                    "gIg",
                    "gIg",
                    "gtg",
                    'g', Blocks.glass_pane,
                    'I', EnumPart.ILLUMAR_PARTS[i].getItemStack(),
                    't', Items.redstone
                    );
            GameRegistry.addRecipe(new ItemStack(ProjectRedIllumination.blockLamp(), 1, i+16), // Inverted
                    "gIg",
                    "gIg",
                    "gtg",
                    'g', Blocks.glass_pane,
                    'I', EnumPart.ILLUMAR_PARTS[i].getItemStack(),
                    't', Blocks.redstone_torch
                    );
        }

        /** Lanterns **/
        for (int i = 0; i < 16; i++)
        {
            GameRegistry.addRecipe(new ItemStack(ProjectRedIllumination.itemPartLantern(), 1, i),
                    "PNP",
                    "GIG",
                    "PRP",
                    'P', EnumPart.PLATE.getItemStack(),
                    'N', Items.gold_nugget,
                    'G', Blocks.glass_pane,
                    'I', EnumPart.ILLUMAR_PARTS[i].getItemStack(),
                    'R', Items.redstone
                    );
            GameRegistry.addRecipe(new ItemStack(ProjectRedIllumination.itemPartInvLantern(), 1, i),
                    "PNP",
                    "GIG",
                    "PRP",
                    'P', EnumPart.PLATE.getItemStack(),
                    'N', Items.gold_nugget,
                    'G', Blocks.glass_pane,
                    'I', EnumPart.ILLUMAR_PARTS[i].getItemStack(),
                    'R', Blocks.redstone_torch
                    );
        }

        /** Buttons **/
        for (int i = 0; i < 16; i++)
            GameRegistry.addShapelessRecipe(
                    new ItemStack(ProjectRedIllumination.itemPartIllumarButton(), 1, i),
                    Blocks.stone_button,
                    EnumPart.ILLUMAR_PARTS[i].getItemStack(),
                    EnumPart.ILLUMAR_PARTS[i].getItemStack()
                    );

        /** Cage Lamps **/
        for (int i = 0; i < 16; i++)
        {
            GameRegistry.addRecipe(new ItemStack(ProjectRedIllumination.itemPartCageLamp(), 1, i),
                    "CCC",
                    "CIC",
                    "NPN",
                    'C', Blocks.iron_bars,
                    'I', EnumPart.ILLUMAR_PARTS[i].getItemStack(),
                    'N', Items.gold_nugget,
                    'P', EnumPart.CONDUCTIVEPLATE.getItemStack()
                    );
            GameRegistry.addRecipe(new ItemStack(ProjectRedIllumination.itemPartInvCageLamp(), 1, i),
                    "CCC",
                    "CIC",
                    "NPN",
                    'C', Blocks.iron_bars,
                    'I', EnumPart.ILLUMAR_PARTS[i].getItemStack(),
                    'N', Items.gold_nugget,
                    'P', EnumPart.CATHODE.getItemStack()
                    );
        }

        /** Fixtures **/
        for (int i = 0; i < 16; i++)
        {
            GameRegistry.addRecipe(new ItemStack(ProjectRedIllumination.itemPartFixture(), 1, i),
                    "ggg",
                    "gIg",
                    "pPp",
                    'g', Blocks.glass_pane,
                    'I', EnumPart.ILLUMAR_PARTS[i].getItemStack(),
                    'p', EnumPart.PLATE.getItemStack(),
                    'P', EnumPart.CONDUCTIVEPLATE.getItemStack()
                    );
            GameRegistry.addRecipe(new ItemStack(ProjectRedIllumination.itemPartInvFixture(), 1, i),
                    "ggg",
                    "gIg",
                    "pPp",
                    'g', Blocks.glass_pane,
                    'I', EnumPart.ILLUMAR_PARTS[i].getItemStack(),
                    'p', EnumPart.PLATE.getItemStack(),
                    'P', EnumPart.CATHODE.getItemStack()
                    );
        }
    }
}

