package mrtjp.projectred.illumination;

import gcewing.codechicken.lib.vec.BlockCoord;
import gcewing.codechicken.lib.vec.Vector3;
//import codechicken.multipart.JItemMultiPart;
import projectred.core.PRItemMultiPart;
import codechicken.multipart.TMultiPart;
import codechicken.multipart.minecraft.ButtonPart;
import cpw.mods.fml.relauncher.Side;
import cpw.mods.fml.relauncher.SideOnly;
import mrtjp.projectred.ProjectRedIllumination;
import net.minecraft.block.Block;
import net.minecraft.client.renderer.texture.IIconRegister;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.util.IIcon;
import net.minecraft.world.World;
import net.minecraftforge.common.util.ForgeDirection;
import cpw.mods.fml.common.registry.GameRegistry;

import java.util.List;

public class ItemPartIllumarButton extends PRItemMultiPart //was JItemMultiPart
{
    public static IIcon icons[];

    public ItemPartIllumarButton(String name)
    {
        this.setHasSubtypes(true);
        this.setUnlocalizedName(name);
        this.setCreativeTab(ProjectRedIllumination.tabLighting());
        GameRegistry.registerItem(this, name);
    }

    @Override
    public boolean onItemUse(ItemStack stack, EntityPlayer player, World w, int x, int y, int z, int side, float f, float f2, float f3)
    {
        if (super.onItemUse(stack, player, w, x, y, z, side, f, f2, f3))
        {
            w.playSoundEffect(x + 0.5, y + 0.5, z + 0.5, Block.soundTypeGlass.func_150496_b(), Block.soundTypeGlass.getVolume() * 5.0F, Block.soundTypeGlass.getPitch() * .9F);
            return true;
        }
        return false;
    }

    @Override
    public TMultiPart newPart(ItemStack is, EntityPlayer player, World w, BlockCoord pos, int side, Vector3 arg5)
    {
        if (side == 0 || side == 1)
            return null;

        pos = pos.copy().offset(side ^ 1);
        if (!w.isSideSolid(pos.x, pos.y, pos.z, ForgeDirection.getOrientation(side)))
            return null;

        IllumarButtonPart b = new IllumarButtonPart(ButtonPart.sideMetaMap[side ^ 1]);
        if (b != null)
            b.onPlaced(is);
        return b;
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void getSubItems(Item item, CreativeTabs tab, List list)
    {
        for (int i = 0; i < 16; i++)
            list.add(new ItemStack(this, 1, i));
    }

    @Override
    public String getUnlocalizedName(ItemStack stack)
    {
        return super.getUnlocalizedName() + "|" + stack.getItemDamage();
    }

    @Override
    @SideOnly(Side.CLIENT)
    public void registerIcons(IIconRegister reg)
    {
        icons = new IIcon[16];
        for (int i = 0; i < 16; i++)
            icons[i] = reg.registerIcon("projectred:lights/button/" + i);
    }

    @Override
    @SideOnly(Side.CLIENT)
    public int getSpriteNumber()
    {
        return 0;
    }
}
