package mrtjp.projectred.illumination

import codechicken.multipart.{TMultiPart, MultiPartRegistry}
import cpw.mods.fml.common.registry.GameRegistry
import mrtjp.projectred.ProjectRedIllumination._
import mrtjp.projectred.core.{Configurator, IProxy}
import codechicken.multipart.MultiPartRegistry.IPartFactory
import cpw.mods.fml.relauncher.{Side, SideOnly}
import net.minecraftforge.client.MinecraftForgeClient
import mrtjp.projectred.ProjectRedIllumination
import cpw.mods.fml.client.registry.ClientRegistry
import net.minecraftforge.common.MinecraftForge
import mrtjp.projectred.core.utils.ItemKey
import net.minecraft.item.Item

class IlluminationProxy_server extends IProxy with IPartFactory
{
    override def preinit() {
        MultiPartRegistry.registerParts(this, Array[String]("pr_lantern", "pr_lightbutton", "pr_cagelamp", "pr_fixture"))

        itemPartLantern = new ItemPartLantern(false)
        itemPartInvLantern = new ItemPartLantern(true)
        itemPartCageLamp = new ItemPartCageLamp(false)
        itemPartInvCageLamp = new ItemPartCageLamp(true)
        itemPartFixture = new ItemPartFixture(false)
        itemPartInvFixture = new ItemPartFixture(true)

        itemPartIllumarButton = new ItemPartIllumarButton("projectred.illumination.lightbutton")

        blockLamp = new BlockLamp("projectred.illumination.lamp")
        GameRegistry.registerTileEntity(classOf[TileLamp], "tile.projectred.illumination.lamp")

        blockAirousLight = new BlockAirousLight("projectred.illumination.airousLight")
        GameRegistry.registerTileEntity(classOf[TileAirousLight], "tile.projectred.illumination.airousLight")
    }

    override def init()
    {
    }

    override def postinit()
    {
        IlluminationRecipes.initRecipes()
    }

    override def createPart(name:String, client:Boolean) = name match
    {
        case "pr_lantern" => new LanternPart
        case "pr_lightbutton" => new IllumarButtonPart
        case "pr_cagelamp" => new CageLampPart
        case "pr_fixture" => new FixturePart
    }

    override def version = "@VERSION@"
    override def build = "@BUILD_NUMBER@"
}

class IlluminationProxy_client extends IlluminationProxy_server
{
    @SideOnly(Side.CLIENT)
    override def init()
    {
        super.init()

        MinecraftForgeClient.registerItemRenderer(ProjectRedIllumination.itemPartLantern, RenderLantern.instance)
        MinecraftForgeClient.registerItemRenderer(ProjectRedIllumination.itemPartInvLantern, RenderLantern.instance)
        MinecraftForgeClient.registerItemRenderer(ProjectRedIllumination.itemPartIllumarButton, RenderIllumarButton.instance)
        MinecraftForgeClient.registerItemRenderer(ProjectRedIllumination.itemPartCageLamp, RenderCageLamp.instance)
        MinecraftForgeClient.registerItemRenderer(ProjectRedIllumination.itemPartInvCageLamp, RenderCageLamp.instance)
        MinecraftForgeClient.registerItemRenderer(ProjectRedIllumination.itemPartFixture, RenderFixture.instance)
        MinecraftForgeClient.registerItemRenderer(ProjectRedIllumination.itemPartInvFixture, RenderFixture.instance)
        MinecraftForgeClient.registerItemRenderer(Item.getItemFromBlock(ProjectRedIllumination.blockLamp), LampTESR.instance)

        ClientRegistry.bindTileEntitySpecialRenderer(classOf[TileLamp], LampTESR.instance)

        MinecraftForge.EVENT_BUS.register(RenderHalo.instance)
    }
}

object IlluminationProxy extends IlluminationProxy_client